Colt 1.2.0

## cern.colt.matrix.impl
Class SparseObjectMatrix2D

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.matrix.impl.AbstractMatrix
              cern.colt.matrix.impl.AbstractMatrix2D
                  cern.colt.matrix.ObjectMatrix2D
                      cern.colt.matrix.impl.SparseObjectMatrix2D

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class SparseObjectMatrix2D

extends ObjectMatrix2D

Sparse hashed 2-d matrix holding `Object` elements. First see the package summary and javadoc tree view to get the broad picture.

Implementation:

Note that this implementation is not synchronized. Uses a `OpenIntObjectHashMap`, which is a compact and performant hashing technique.

Memory requirements:

Cells that

- are never set to non-zero values do not use any memory.
- switch from zero to non-zero state do use memory.
- switch back from non-zero to zero state also do use memory. However, their memory is automatically reclaimed from time to time. It can also manually be reclaimed by calling `trimToSize()`.

worst case: `memory [bytes] = (1/minLoadFactor) * nonZeros * 13`.
best case: `memory [bytes] = (1/maxLoadFactor) * nonZeros * 13`.
Where `nonZeros = cardinality()` is the number of non-zero cells. Thus, a 1000 x 1000 matrix with minLoadFactor=0.25 and maxLoadFactor=0.5 and 1000000 non-zero cells consumes between 25 MB and 50 MB. The same 1000 x 1000 matrix with 1000 non-zero cells consumes between 25 and 50 KB.

Time complexity:

This class offers expected time complexity `O(1)` (i.e. constant time) for the basic operations `get`, `getQuick`, `set`, `setQuick` and `size` assuming the hash function disperses the elements properly among the buckets. Otherwise, pathological cases, although highly improbable, can occur, degrading performance to `O(N)` in the worst case. As such this sparse class is expected to have no worse time complexity than its dense counterpart `DenseObjectMatrix2D`. However, constant factors are considerably larger.

Cells are internally addressed in row-major. Performance sensitive applications can exploit this fact. Setting values in a loop row-by-row is quicker than column-by-column, because fewer hash collisions occur. Thus

            for (int row=0; row < rows; row++) {
                    for (int column=0; column < columns; column++) {
                            matrix.setQuick(row,column,someValue);
                    }
            }

is quicker than

            for (int column=0; column < columns; column++) {
                    for (int row=0; row < rows; row++) {
                            matrix.setQuick(row,column,someValue);
                    }
            }

Version:
  1.0, 09/24/99
See Also:
  `cern.colt.map`, `OpenIntObjectHashMap`, Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Constructor Summary
`SparseObjectMatrix2D(int rows, int columns)` Constructs a matrix with a given number of rows and columns and default memory usage.
`SparseObjectMatrix2D(int rows, int columns, int initialCapacity, double minLoadFactor, double maxLoadFactor)` Constructs a matrix with a given number of rows and columns using memory as specified.
`SparseObjectMatrix2D(java.lang.Object[][] values)` Constructs a matrix with a copy of the given values.

Method Summary
`int` `cardinality()` Returns the number of cells having non-zero values.
`void` `ensureCapacity(int minCapacity)` Ensures that the receiver can hold at least the specified number of non-zero cells without needing to allocate new internal memory.
`java.lang.Object` `getQuick(int row, int column)` Returns the matrix cell value at coordinate `[row,column]`.
`ObjectMatrix2D` `like(int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns.
`ObjectMatrix1D` `like1D(int size)` Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver.
`void` `setQuick(int row, int column, java.lang.Object value)` Sets the matrix cell at coordinate `[row,column]` to the specified value.
`void` `trimToSize()` Releases any superfluous memory created by explicitly putting zero values into cells formerly having non-zero values; An application can use this operation to minimize the storage of the receiver.

Methods inherited from class cern.colt.matrix.ObjectMatrix2D
`aggregate, aggregate, assign, assign, assign, assign, assign, copy, equals, equals, get, getNonZeros, like, set, toArray, toString, viewColumn, viewColumnFlip, viewDice, viewPart, viewRow, viewRowFlip, viewSelection, viewSelection, viewSorted, viewStrides`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix2D
`checkShape, checkShape, columns, rows, size, toStringShort`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SparseObjectMatrix2D

    public SparseObjectMatrix2D(java.lang.Object[][] values)

  Constructs a matrix with a copy of the given values. `values` is required to have the form `values[row][column]` and have exactly the same number of columns in every row.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

  Parameters:
    `values` - The values to be filled into the new matrix.
  Throws:
    `java.lang.IllegalArgumentException` - if `for any 1 <= row < values.length: values[row].length != values[row-1].length`.

### SparseObjectMatrix2D

    public SparseObjectMatrix2D(int rows,
                                int columns)

  Constructs a matrix with a given number of rows and columns and default memory usage. All entries are initially `null`.

  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Throws:
    `java.lang.IllegalArgumentException` - if `rows<0 || columns<0 || (double)columns*rows > Integer.MAX_VALUE`.

### SparseObjectMatrix2D

    public SparseObjectMatrix2D(int rows,
                                int columns,
                                int initialCapacity,
                                double minLoadFactor,
                                double maxLoadFactor)

  Constructs a matrix with a given number of rows and columns using memory as specified. All entries are initially `null`. For details related to memory usage see `OpenIntObjectHashMap`.

  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
    `initialCapacity` - the initial capacity of the hash map. If not known, set `initialCapacity=0` or small.
    `minLoadFactor` - the minimum load factor of the hash map.
    `maxLoadFactor` - the maximum load factor of the hash map.
  Throws:
    `java.lang.IllegalArgumentException` - if `initialCapacity < 0 || (minLoadFactor < 0.0 || minLoadFactor >= 1.0) || (maxLoadFactor <= 0.0 || maxLoadFactor >= 1.0) || (minLoadFactor >= maxLoadFactor)`.
    `java.lang.IllegalArgumentException` - if `rows<0 || columns<0 || (double)columns*rows > Integer.MAX_VALUE`.

Method Detail

### cardinality

    public int cardinality()

  Returns the number of cells having non-zero values.

  Overrides:
    `cardinality` in class `ObjectMatrix2D`

### ensureCapacity

    public void ensureCapacity(int minCapacity)

  Ensures that the receiver can hold at least the specified number of non-zero cells without needing to allocate new internal memory. If necessary, allocates new internal memory and increases the capacity of the receiver.

  This method never need be called; it is for performance tuning only. Calling this method before tt>set()ing a large number of non-zero values boosts performance, because the receiver will grow only once instead of potentially many times and hash collisions get less probable.

  Overrides:
    `ensureCapacity` in class `AbstractMatrix`
  Parameters:
    `minNonZeros` - the desired minimum number of non-zero cells.

### getQuick

    public java.lang.Object getQuick(int row,
                                     int column)

  Returns the matrix cell value at coordinate `[row,column]`.

  Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

  Specified by:
    `getQuick` in class `ObjectMatrix2D`
  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value at the specified coordinate.

### like

    public ObjectMatrix2D like(int rows,
                               int columns)

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns. For example, if the receiver is an instance of type `DenseObjectMatrix2D` the new matrix must also be of type `DenseObjectMatrix2D`, if the receiver is an instance of type `SparseObjectMatrix2D` the new matrix must also be of type `SparseObjectMatrix2D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Specified by:
    `like` in class `ObjectMatrix2D`
  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Returns:
    a new empty matrix of the same dynamic type.

### like1D

    public ObjectMatrix1D like1D(int size)

  Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver. For example, if the receiver is an instance of type `DenseObjectMatrix2D` the new matrix must be of type `DenseObjectMatrix1D`, if the receiver is an instance of type `SparseObjectMatrix2D` the new matrix must be of type `SparseObjectMatrix1D`, etc.

  Specified by:
    `like1D` in class `ObjectMatrix2D`
  Parameters:
    `size` - the number of cells the matrix shall have.
  Returns:
    a new matrix of the corresponding dynamic type.

### setQuick

    public void setQuick(int row,
                         int column,
                         java.lang.Object value)

  Sets the matrix cell at coordinate `[row,column]` to the specified value.

  Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

  Specified by:
    `setQuick` in class `ObjectMatrix2D`
  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.

### trimToSize

    public void trimToSize()

  Releases any superfluous memory created by explicitly putting zero values into cells formerly having non-zero values; An application can use this operation to minimize the storage of the receiver.

  Background:

  Cells that

  - are never set to non-zero values do not use any memory.
  - switch from zero to non-zero state do use memory.
  - switch back from non-zero to zero state also do use memory. However, their memory can be reclaimed by calling `trimToSize()`.
  A sequence like `set(r,c,5); set(r,c,0);` sets a cell to non-zero state and later back to zero state. Such as sequence generates obsolete memory that is automatically reclaimed from time to time or can manually be reclaimed by calling `trimToSize()`. Putting zeros into cells already containing zeros does not generate obsolete memory since no memory was allocated to them in the first place.

  Overrides:
    `trimToSize` in class `AbstractMatrix`

Colt 1.2.0

Jump to the Colt Homepage